/*
 * DiceGameTest.h
 */

#ifndef dicegame_tests_DiceGameTest_h
#define dicegame_tests_DiceGameTest_h

#include "dicegame/DiceGameListener.h"
#include <cppunit/TestCase.h>

USING_NAMESPACE_CPPUNIT

class DiceGameTest : public TestCase
{
  public:
	explicit DiceGameTest(const char* name) : TestCase(name) {}
	void testCreate();
	void testInquireOddOrEven();
	void testJudge();
	void testDoRound();
	void testRun();

	static Test* suite();

  public:
	class TestListener : public DiceGameListener {
	  public:
		TestListener() : started(0), ended(0), inquired(0) {}
		virtual void startRound() { ++started; }
		virtual void endRound() { ++ended; }
		virtual int inquireOddOrEven();
		int started, ended, inquired;
	};
};

#endif /* !dicegame_tests_DiceGameTest_h */
